<script lang="ts" setup>
import { ref, watch, defineProps } from "vue";
interface ReturnValue {
  item: string;
  index: number;
}
interface Emits {
  (event: "update:modelValue", value: File | File[]): void;
  (event: "remove", value: ReturnValue | string): void;
  (event: "show", value: ReturnValue | string): void;
}

interface Props {
  modelValue: string | string[];
}

const props = defineProps<Props>();
const emit = defineEmits<Emits>();
const inputValue = ref<string | string[]>();

watch(
  () => props.modelValue,
  () => {
    console.log(props.modelValue);
    
    inputValue.value = props.modelValue;
  }
);

const onInputFile = (value) => {
  const valueSize: File[] = Object.values(value.target.files);
  if (valueSize.length === 1) emit("update:modelValue", value.target.files[0]);
  else {
    emit("update:modelValue", valueSize);
  }
};
</script>

<template>
  <input
    class="form-file-input"
    v-bind="props"
    @input="onInputFile"
    v-on="emit"
    type="file"
  />
  <template v-if="typeof inputValue === 'string'">
    <div class="flex justify-between items-center mt-3 mx-5">
      <span class="rounded bg-primary px-4 pb-0.5 text-white">{{
        inputValue.split("/").at(-1)
      }}</span>

      <div class="flex justify-end gap-3">
        <span
          class="text-secondary cursor-pointer"
          uk-icon="eye"
          @click="emit('show', inputValue)"
        ></span>
        <span
          class="text-danger cursor-pointer"
          uk-icon="minus-circle"
          @click="emit('remove', inputValue)"
        ></span>
      </div>
    </div>
  </template>
  <template v-else-if="Array.isArray(inputValue)">
    <div
      class="flex justify-between items-center mt-3 mx-5"
      v-for="(item, index) in inputValue"
    >
      <span class="rounded bg-primary px-4 pb-0.5 text-white">{{
        item.split("/").at(-1)
      }}</span>

      <div class="flex justify-end gap-3">
        <span
          class="text-secondary cursor-pointer"
          uk-icon="eye"
          @click="emit('show', { item, index })"
        ></span>
        <span
          class="text-danger cursor-pointer"
          uk-icon="minus-circle"
          @click="emit('remove', { item, index })"
        ></span>
      </div>
    </div>
  </template>
</template>
